package sdlip.examples.demo;

import java.util.*;

/**
 * A simple default implementation for the TreeNode.
 */

public class BasicNode implements TreeNode {

  boolean open = true;
  String label;
  Vector children = new Vector();


  public BasicNode() {
  }

  public BasicNode(String label) {
    this.label = label;
  }

  public boolean getOpen() {
    return open;
  }
  public void setOpen(boolean b) {
    this.open = b;
  }
  public String getLabel() {
    return label;
  }

  public void addChild(TreeNode n) {
    children.addElement(n);
  }

  /**
   * return next sibling after removed child
   */
  public TreeNode removeChild(TreeNode n) {
    int i = children.indexOf(n);
    if(i >= 0) {
      children.removeElementAt(i);
      if(i == children.size())
	i--;
      if(i >= 0)
	return (TreeNode)children.elementAt(i);
    }
    return null;
  }

  public Enumeration children() {
    return children.elements();
  }
  
}
