package sdlip.xml;
//
// XMLEntities.java
//
//

import java.util.Hashtable;

public class XMLEntities {

  private static Hashtable entityToUnicode = new Hashtable();

  public XMLEntities() {
    entityToUnicode.put( "&nbsp;", new Character('\u00A0' ) );
    entityToUnicode.put( "&iexcl;", new Character('\u00A1' ) );
    entityToUnicode.put( "&cent;", new Character('\u00A2' ) );
    entityToUnicode.put( "&pound;", new Character('\u00A3' ) );
    entityToUnicode.put( "&curren;", new Character('\u00A4' ) );
    entityToUnicode.put( "&yen;", new Character('\u00A5' ) );
    entityToUnicode.put( "&brvbar;", new Character('\u00A6' ) );
    entityToUnicode.put( "&sect;", new Character('\u00A7' ) );
    entityToUnicode.put( "&uml;", new Character('\u00A8' ) );
    entityToUnicode.put( "&copy;", new Character('\u00A9' ) );
    entityToUnicode.put( "&ordf;", new Character('\u00AA' ) );
    entityToUnicode.put( "&laquo;", new Character('\u00AB' ) );
    entityToUnicode.put( "&not;", new Character('\u00AC' ) );
    entityToUnicode.put( "&shy;", new Character('\u00AD' ) );
    entityToUnicode.put( "&reg;", new Character('\u00AE' ) );
    entityToUnicode.put( "&macr;", new Character('\u00AF' ) );
    entityToUnicode.put( "&deg;", new Character('\u00B0' ) );
    entityToUnicode.put( "&plusmn;", new Character('\u00B1' ) );
    entityToUnicode.put( "&sup2;", new Character('\u00B2' ) );
    entityToUnicode.put( "&sup3;", new Character('\u00B3' ) );
    entityToUnicode.put( "&acute;", new Character('\u00B4' ) );
    entityToUnicode.put( "&micro;", new Character('\u00B5' ) );
    entityToUnicode.put( "&para;", new Character('\u00B6' ) );
    entityToUnicode.put( "&middot;", new Character('\u00B7' ) );
    entityToUnicode.put( "&cedil;", new Character('\u00B8' ) );
    entityToUnicode.put( "&sup1;", new Character('\u00B9' ) );
    entityToUnicode.put( "&ordm;", new Character('\u00BA' ) );
    entityToUnicode.put( "&raquo;", new Character('\u00BB' ) );
    entityToUnicode.put( "&frac14;", new Character('\u00BC' ) );
    entityToUnicode.put( "&frac12;", new Character('\u00BD' ) );
    entityToUnicode.put( "&frac34;", new Character('\u00BE' ) );
    entityToUnicode.put( "&iquest;", new Character('\u00BF' ) );
    entityToUnicode.put( "&Agrave;", new Character('\u00C0' ) );
    entityToUnicode.put( "&Aacute;", new Character('\u00C1' ) );
    entityToUnicode.put( "&Acirc;", new Character('\u00C2' ) );
    entityToUnicode.put( "&Atilde;", new Character('\u00C3' ) );
    entityToUnicode.put( "&Auml;", new Character('\u00C4' ) );
    entityToUnicode.put( "&Aring;", new Character('\u00C5' ) );
    entityToUnicode.put( "&AElig;", new Character('\u00C6' ) );
    entityToUnicode.put( "&Ccedil;", new Character('\u00C7' ) );
    entityToUnicode.put( "&Egrave;", new Character('\u00C8' ) );
    entityToUnicode.put( "&Eacute;", new Character('\u00C9' ) );
    entityToUnicode.put( "&Ecirc;", new Character('\u00CA' ) );
    entityToUnicode.put( "&Euml;", new Character('\u00CB' ) );
    entityToUnicode.put( "&Igrave;", new Character('\u00CC' ) );
    entityToUnicode.put( "&Iacute;", new Character('\u00CD' ) );
    entityToUnicode.put( "&Icirc;", new Character('\u00CE' ) );
    entityToUnicode.put( "&Iuml;", new Character('\u00CF' ) );
    entityToUnicode.put( "&ETH;", new Character('\u00D0' ) );
    entityToUnicode.put( "&Ntilde;", new Character('\u00D1' ) );
    entityToUnicode.put( "&Ograve;", new Character('\u00D2' ) );
    entityToUnicode.put( "&Oacute;", new Character('\u00D3' ) );
    entityToUnicode.put( "&Ocirc;", new Character('\u00D4' ) );
    entityToUnicode.put( "&Otilde;", new Character('\u00D5' ) );
    entityToUnicode.put( "&Ouml;", new Character('\u00D6' ) );
    entityToUnicode.put( "&times;", new Character('\u00D7' ) );
    entityToUnicode.put( "&Oslash;", new Character('\u00D8' ) );
    entityToUnicode.put( "&Ugrave;", new Character('\u00D9' ) );
    entityToUnicode.put( "&Uacute;", new Character('\u00DA' ) );
    entityToUnicode.put( "&Ucirc;", new Character('\u00DB' ) );
    entityToUnicode.put( "&Uuml;", new Character('\u00DC' ) );
    entityToUnicode.put( "&Yacute;", new Character('\u00DD' ) );
    entityToUnicode.put( "&THORN;", new Character('\u00DE' ) );
    entityToUnicode.put( "&szlig;", new Character('\u00DF' ) );
    entityToUnicode.put( "&agrave;", new Character('\u00E0' ) );
    entityToUnicode.put( "&aacute;", new Character('\u00E1' ) );
    entityToUnicode.put( "&acirc;", new Character('\u00E2' ) );
    entityToUnicode.put( "&atilde;", new Character('\u00E3' ) );
    entityToUnicode.put( "&auml;", new Character('\u00E4' ) );
    entityToUnicode.put( "&aring;", new Character('\u00E5' ) );
    entityToUnicode.put( "&aelig;", new Character('\u00E6' ) );
    entityToUnicode.put( "&ccedil;", new Character('\u00E7' ) );
    entityToUnicode.put( "&egrave;", new Character('\u00E8' ) );
    entityToUnicode.put( "&eacute;", new Character('\u00E9' ) );
    entityToUnicode.put( "&ecirc;", new Character('\u00EA' ) );
    entityToUnicode.put( "&euml;", new Character('\u00EB' ) );
    entityToUnicode.put( "&igrave;", new Character('\u00EC' ) );
    entityToUnicode.put( "&iacute;", new Character('\u00ED' ) );
    entityToUnicode.put( "&icirc;", new Character('\u00EE' ) );
    entityToUnicode.put( "&iuml;", new Character('\u00EF' ) );
    entityToUnicode.put( "&eth;", new Character('\u00F0' ) );
    entityToUnicode.put( "&ntilde;", new Character('\u00F1' ) );
    entityToUnicode.put( "&ograve;", new Character('\u00F2' ) );
    entityToUnicode.put( "&oacute;", new Character('\u00F3' ) );
    entityToUnicode.put( "&ocirc;", new Character('\u00F4' ) );
    entityToUnicode.put( "&otilde;", new Character('\u00F5' ) );
    entityToUnicode.put( "&ouml;", new Character('\u00F6' ) );
    entityToUnicode.put( "&divide;", new Character('\u00F7' ) );
    entityToUnicode.put( "&oslash;", new Character('\u00F8' ) );
    entityToUnicode.put( "&ugrave;", new Character('\u00F9' ) );
    entityToUnicode.put( "&uacute;", new Character('\u00FA' ) );
    entityToUnicode.put( "&ucirc;", new Character('\u00FB' ) );
    entityToUnicode.put( "&uuml;", new Character('\u00FC' ) );
    entityToUnicode.put( "&yacute;", new Character('\u00FD' ) );
    entityToUnicode.put( "&thorn;", new Character('\u00FE' ) );
    entityToUnicode.put( "&yuml;", new Character('\u00FF' ) );
  }

  public char getCharacter(String s) {
    Character result = (Character) entityToUnicode.get(s);
    if (result == null) {
      return '\u007F';
    } else {
      return result.charValue();
    }
  }  

  public String normalizeData( String s ) {
    // find all instances
    int pos = 0;
    int startEntity = s.indexOf('&');
    int endEntity;
    int nextSpace;
    int nextNewLine;
    StringBuffer result = new StringBuffer(""); 
    while (startEntity != -1) {
      result.append(s.substring(pos, startEntity));
      endEntity = s.indexOf(';', startEntity);
      nextSpace = s.indexOf(' ', startEntity);
      nextNewLine = s.indexOf('\n', startEntity);
      if  ((endEntity == -1) ||
	   ((nextSpace != -1) && (endEntity>nextSpace)) ||
	   ((nextNewLine != -1) && (endEntity>nextNewLine))) {
	// this is a lonely & and not a real entity
	result.append("&");
	pos = startEntity+1;
      } else {
	// this is a proper entity
	result.append(getCharacter(s.substring(startEntity,endEntity+1)));
	pos = endEntity + 1;
      }
      startEntity = s.indexOf('&',pos);
    }
    result.append(s.substring(pos, s.length()));
    //    System.out.println(result);
    return result.toString();
  }

  public static void main(String[] args) throws Exception {
    XMLEntities e = new XMLEntities();
    //    String test1 = "hello world!";
    //    String test2 = "&iquest;Est&agrave; el ni&ntilde;o aqu&igrave;?";
    String test3 = "P&G vend la p&acirc;te dentifrice et les m&egrave;decines dans les Pyr&egrave;n&egrave;es\nP&G makes good products\nProcter&Gamble is is also spelled this way\nP&G is a big company";
    //    System.out.println(test3);
    System.out.println(e.normalizeData(test3));
  }

}
