package sdlip;

import org.omg.CORBA.IntHolder;

/**
 * This is the Java mapping of the SDLIP Metadata interface.
 */

public interface Metadata {

  public void getInterface(
			   XMLObject theInterface /* XML-encoded info about the versions of each
						     supported interface. */
			   )
    throws SDLIPException;

  public void getSubcollectionInfo(
				   /* XML list of subcollections and their
				      supported query languages */
				   XMLObject subcolInfo
				   )
    throws SDLIPException;

  public void getPropertyInfo(
			      /* {null} If not supplied, request for default
				 subcollection. */
			      String subcolName, 
			      /* Acceptable properties of
				 specified subcollection, and whether they are
				 searchable/retrievable */
			      XMLObject propInfo
			      )
    throws SDLIPException;

}
