package sdlip.http;

import java.util.*;
import java.io.*;

public class HTTPUtil {

  /** reads header, field names are in lower case */
  public static Hashtable getMIMEHeader(BufferedReader din) throws IOException {
    
    Hashtable header = new Hashtable();
    
    do {
      String line = din.readLine();
      if(line == null) {
	//	http.sendError("No HTTP header", this);
	break; // error
      }
      if(line.length() == 0)
	break; // header ended
      // find colon
      int colon = line.indexOf(':');
      if(colon < 1)
	break; // error
      header.put( line.substring(0, colon).toLowerCase(), line.substring(colon + 2) );
      //	  System.err.println("HEADER: " + line.substring(0, colon) + "=" + line.substring(colon+2));
    } while (true);
    
    return header;
  }

    /**
     * Returns the length of this string's UTF encoded form.
    public static int utfLength(String s) {
      int limit = s.length();
      int utflen = 0;
      for (int i = 0; i < limit; i++) {
	int c = (int)s.charAt(i);
	if ((c >= 0x0001) && (c <= 0x007F)) {
	  utflen++;
	} else if (c > 0x07FF) {
	  utflen += 3;
	} else {
	  utflen += 2;
	}
      }
      return utflen;
    }
     */


}
